/*---------------------------------------------------------------------------
               MQO`3DfǂݍŃ}[J̏ɕ\
---------------------------------------------------------------------------*/

#ifdef _WIN32
#include <windows.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#ifndef __APPLE__
#include <GL/gl.h>
#include <GL/glut.h>
#else
#include <OpenGL/gl.h>
#include <GLUT/glut.h>
#endif

#include <AR/ar.h>
#include <AR/param.h>
#include <AR/video.h>
#include <AR/gsub.h>

#include "GLMetaseq.h"	// f[_

// Cu̐ݒ
#ifdef _DEBUG
	#pragma comment(lib,"libARd.lib")
	#pragma comment(lib,"libARgsubd.lib")
	#pragma comment(lib,"libARvideod.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmtd.lib")
#else
	#pragma comment(lib,"libAR.lib")
	#pragma comment(lib,"libARgsub.lib")
	#pragma comment(lib,"libARvideo.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")
#endif


// O[oϐ
char	*vconf_name		= "Data/WDM_camera_flipV.xml";	// rfIfoCX̐ݒt@C
char	*cparam_name    = "Data/camera_para.dat";		// Jp[^t@C
char	*patt_name      = "Data/patt.hiro";				// p^[t@C
char	*mqo_name		= "Data/ninja.mqo";				// MQOt@C

int		patt_id;						// p^[ID
double	patt_trans[3][4];				// Wϊs
double	patt_center[2]	= { 0.0, 0.0 };	// p^[̒SW
double	patt_width		= 80.0;			// p^[̃TCYiPʁFmmj
int		thresh			= 100;			// 2l臒l

MQO_MODEL	model;		// f


// vg^Cv錾
void MainLoop(void);
void DrawObject(void);
void KeyEvent(unsigned char key, int x, int y);
void Cleanup(void);
void SetLight( GLenum light );


//===========================================================================
// main֐
//===========================================================================
int main( int argc, char **argv )
{
	ARParam	cparam;			// Jp[^
	ARParam	wparam;			// Jp[^iƗpϐj
	int		xsize, ysize;	// 摜TCY

	// GLUT̏
	glutInit( &argc, argv );

	// rfIfoCX̐ݒ
	if ( arVideoOpen( vconf_name ) < 0 ) {
		printf("rfIfoCX̃G[");
		return -1;
	}

	// Jp[^̐ݒ
	if ( arVideoInqSize( &xsize, &ysize ) < 0 ) {
		printf("摜TCY擾ł܂ł\n");
		return -1;
	}
	if ( arParamLoad( cparam_name, 1, &wparam ) < 0 ) {
		printf("Jp[^̓ǂݍ݂Ɏs܂\n");
		return -1;
	}
	arParamChangeSize( &wparam, xsize, ysize, &cparam );
	arInitCparam( &cparam );

	// p^[t@C̃[h
	if ( (patt_id = arLoadPatt(patt_name)) < 0 ) {
		printf("p^[t@C̓ǂݍ݂Ɏs܂\n");
		return -1;
	}

	// EBhE̐ݒ
	argInit( &cparam, 1.0, 0, 0, 0, 0 );
	glutSetWindowTitle("MQO Loader on ARToolKit");

	// GLMetaseq̏
	mqoInit();

	// f̓ǂݍ
	if ( (model = mqoCreateModel( mqo_name, 1.0 )) == NULL ) {
		printf("f̓ǂݍ݂Ɏs܂\n");
		return -1;
	}

	// rfILv`̊Jn
	arVideoCapStart();

	// C[v̊Jn
	argMainLoop( NULL, KeyEvent, MainLoop );

	return 0;
}


//===========================================================================
// C[v֐
//===========================================================================
void MainLoop(void)
{
	ARUint8			*image;
	ARMarkerInfo	*marker_info;
	int				marker_num;
	int				j, k;

	// J摜̎擾
	if ( (image = arVideoGetImage()) == NULL ) {
		arUtilSleep( 2 );
		return;
	}

	// J摜̕`
	argDrawMode2D();
	argDispImage( image, 0, 0 );

	// }[J̌oƔF
	if ( arDetectMarker( image, thresh, &marker_info, &marker_num ) < 0 ) {
		Cleanup();
		exit(0);
	}

	// ̉摜̃Lv`w
	arVideoCapNext();

	// }[J̐Mx̔r
	k = -1;
	for( j = 0; j < marker_num; j++ ) {
		if ( patt_id == marker_info[j].id ) {
			if ( k == -1 ) k = j;
			else if ( marker_info[k].cf < marker_info[j].cf ) k = j;
		}
	}

	if ( k != -1 ) {
		// }[J̈ʒuEpiWϊsǰvZ
		arGetTransMat( &marker_info[k], patt_center, patt_width, patt_trans );

		// 3DIuWFNg̕`
		DrawObject();
	}

	// obt@̓eʂɕ\
	argSwapBuffers();
}


//===========================================================================
// ̐ݒs֐
//===========================================================================
void SetLight( GLenum light )
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( light, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( light, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( light, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( light, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glEnable(light);	// ̗L
}


//===========================================================================
// 3DIuWFNg̕`s֐
//===========================================================================
void DrawObject(void)
{
	double	gl_para[16];

	// 3DIuWFNg`悷邽߂̏
	argDrawMode3D();
	argDraw3dCamera( 0, 0 );

	glPushMatrix();
		SetLight(GL_LIGHT0);		// ̐ݒi_ɑ΂ČŒj
	glPopMatrix();

	// Wϊs̓Kp
	argConvGlpara( patt_trans, gl_para );
	glMatrixMode( GL_MODELVIEW );
	glLoadMatrixd( gl_para );

	// 3DIuWFNg̕`
	glClear( GL_DEPTH_BUFFER_BIT );			// Zobt@̏
	glEnable( GL_DEPTH_TEST );				// Bʏ̓Kp
	glEnable( GL_LIGHTING );				// ̓Kp

	glPushMatrix();
		glRotatef( 90.0, 1.0, 0.0, 0.0 );	// f𗧂
		mqoCallModel( model );				// f̕`
	glPopMatrix();

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );
}


//===========================================================================
// L[{[h͏֐
//===========================================================================
void KeyEvent( unsigned char key, int x, int y )
{
	// ESCL[͂AvP[VI
    if ( key == 0x1b ) {
        Cleanup();
        exit(0);
    }
}


//===========================================================================
// I֐
//===========================================================================
void Cleanup(void)
{
    arVideoCapStop();	// rfILv`̒~
    arVideoClose();		// rfIfoCX̏I
    argCleanup();		// OtBbN̏I

	mqoDeleteModel( model );	// f̍폜
	mqoCleanup();				// GLMetaseq̏I
}